Package weka.gui.beans

# Interface OffscreenChartRenderer

All Known Implementing Classes:
  `AbstractOffscreenChartRenderer`, `WekaOffscreenChartRenderer`

public interface OffscreenChartRenderer
Interface to something that can render certain types of charts in headless mode.

Version:
  $Revision: 12055 $
Author:
  Mark Hall (mhall{[at]}pentaho{[dot]}com)

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `optionsTipTextHTML()`
  Gets a short list of additional options (if any), suitable for displaying in a tip text, in HTML form
  `String`
  `rendererName()`
  The name of this off screen renderer
  `BufferedImage`
  `renderHistogram(int width, int height, List<Instances> series, String attsToPlot, List<String> optionalArgs)`
  Render histogram(s) (numeric attribute) or bar chart(s) (nominal attribute).
  `BufferedImage`
  `renderXYLineChart(int width, int height, List<Instances> series, String xAxis, String yAxis, List<String> optionalArgs)`
  Render an XY line chart
  `BufferedImage`
  `renderXYScatterPlot(int width, int height, List<Instances> series, String xAxis, String yAxis, List<String> optionalArgs)`
  Render an XY scatter plot

- ## Method Details

  - ### rendererName

    String rendererName()
    The name of this off screen renderer
    Returns:
      the name of this off screen renderer

  - ### optionsTipTextHTML

    String optionsTipTextHTML()
    Gets a short list of additional options (if any), suitable for displaying in a tip text, in HTML form
    Returns:
      additional options description in simple HTML form

  - ### renderXYLineChart

    BufferedImage renderXYLineChart(int width, int height, List<Instances> series, String xAxis, String yAxis, List<String> optionalArgs) throws Exception
    Render an XY line chart
    Parameters:
      `width` - the width of the resulting chart in pixels
      `height` - the height of the resulting chart in pixels
      `series` - a list of Instances - one for each series to be plotted
      `xAxis` - the name of the attribute for the x-axis (all series Instances are expected to have an attribute of the same type with this name)
      `yAxis` - the name of the attribute for the y-axis (all series Instances are expected to have an attribute of the same type with this name)
      `optionalArgs` - optional arguments to the renderer (may be null)
    Returns:
      a BufferedImage containing the chart
    Throws:
      `Exception` - if there is a problem rendering the chart

  - ### renderXYScatterPlot

    BufferedImage renderXYScatterPlot(int width, int height, List<Instances> series, String xAxis, String yAxis, List<String> optionalArgs) throws Exception
    Render an XY scatter plot
    Parameters:
      `width` - the width of the resulting chart in pixels
      `height` - the height of the resulting chart in pixels
      `series` - a list of Instances - one for each series to be plotted
      `xAxis` - the name of the attribute for the x-axis (all series Instances are expected to have an attribute of the same type with this name)
      `yAxis` - the name of the attribute for the y-axis (all series Instances are expected to have an attribute of the same type with this name)
      `optionalArgs` - optional arguments to the renderer (may be null)
    Returns:
      a BufferedImage containing the chart
    Throws:
      `Exception` - if there is a problem rendering the chart

  - ### renderHistogram

    BufferedImage renderHistogram(int width, int height, List<Instances> series, String attsToPlot, List<String> optionalArgs) throws Exception
    Render histogram(s) (numeric attribute) or bar chart(s) (nominal attribute). Some implementations may not be able to render more than one histogram/pie on the same chart - the implementation can either throw an exception or just process the first series in this case.
    Parameters:
      `width` - the width of the resulting chart in pixels
      `height` - the height of the resulting chart in pixels
      `series` - a list of Instances - one for each series to be plotted
      `attsToPlot` - the name of the attribute to plot (the attribute, with the, same type, must be present in each series)
      `optionalArgs` - optional arguments to the renderer (may be null)
    Returns:
      a BufferedImage containing the chart
    Throws:
      `Exception` - if there is a problem rendering the chart